刚装了个，正好看看bycrowner
10 Things To Do After Installing Ubuntu 13.10
================================================================================
**Ubuntu 13.10 is out, you’ve upgraded, and you’re wondering what to do now. Don’t fret – here are 10 things to do after installing Ubuntu 13.10.**

We put together a post-install checklist for every release of Ubuntu, but as new features arrive and improvements are made, the steps we suggest change and alter.

So what are the best things to do after upgrading to Ubuntu 13.10?

### 1. Get Up To Speed ###

While Ubuntu 13.10 packs in fewer user-facing features than previous releases the effect of the new Smart Scopes Service is hard to miss.

### 2. Enable Additional Drivers ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/04/drivers.jpg)

Ubuntu supports a vast array of hardware right out of the box. But while the free, open-source drivers that make this possible are increasingly capable you may find that performance less that ideal for playing games on Steam or streaming HD video.

If so you may want to **install and enable any proprietary drivers** listed in the Software & Updates tool.

Open the Software Sources app via the Dash (or through System Settings) then click through to the ’Additional Drivers’ tab and follow the on-screen prompts.

### 3. Install Media Codecs in Ubuntu ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/10/mus.jpg)

Due to a big tangle of legal issues Ubuntu is unable to play many popular audio and video formats ‘out of the box’. It’s an inconvenience born of necessity.

But installing what’s needed is only a couple of clicks away.  During installation you can tick the ’*Enable Restricted Formats*’ box to have the required codecs pulled in, or – if you forgot to do that – you can install everything needed to get media working from the Ubuntu Software Centre.

- [Install Third-Party Codecs][1]

### 4. Set Up Your Social Life ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/04/account-toggles.jpg)

Facebook, Twitter, Google Talk, Gmail and a heap more social accounts can be set up in one go using the *Online Accounts* hub.

Just add an network then **decide which applications can use it**. For example, stop Empathy firing up Google Chat by default, and filter our Facebook from the Social Lens.

Services supported include Twitter, Google, Yahoo!, Facebook (including Facebook Chat), Flickr, and a growing number of others.

### 5. Add Additional Apps ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/04/apps.jpg)

Ubuntu offers a lot of neat apps by default but one size doesn’t fit all. If you don’t like a certain app, or find yourself missing something else, you can easily add more software.

Fire up the Ubuntu Software Centre to browse thousands of free applications, including popular choices like:

- **Dropbox** - Popular, cross-platform cloud storage service
- **Steam** – Game distribution platform
- **GIMP** – Advanced image editor
- **VLC** – Popular media player

You’ll also find a wealth of additional software listed on sites like ours – check out our Apps tag for some ideas.

- [View App Posts on OMG! Ubuntu!][2]


### 6. Protect Your Privacy ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/10/priv.jpg)

Privacy is a hot-potato these days, so it’s great to see that the latest release of Ubuntu improves its Privacy offerings with a new look and a handful of extra options.

Whether you want to hide a folder or app from appearing in the Dash, restrict access to your computer after waking up, or choose what data about system crashes is sent back to Canonical, the Privacy & Security pane is where you’ll find all the tools you need.

### 7. Embrace The Web ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/04/gmails.jpg)

Canonical are enticing web devs with word that websites can be easily packaged, integrated and made available for install on Ubuntu Touch.

The genesis of this approach has been included on desktop Ubuntu for a few releases. Over 30 popular websites – including Gmail, Yahoo! & Rd.io - can seamlessly integrate with parts of the desktop.

For example, add GMail and you get fancy Gmail options in the Launcher and Messaging Menu; enable Rd.io and you’ll be able to control playback using the Sound Menu.

### 8. Make Unity Yours ###

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/10/unity_tweak_tool_310.png)

Unity is more customisable than people think. *Unity Tweak Tool* is a third-party app that lets you adjust the Unity desktop experience to suit you.

Options include:

- Adjust launcher transparency 
- Set launcher icon animations
- Enable workspaces
- Configure shortcuts
- Move window controls

And no, before you wonder, it won’t let you move the launcher.

- [Install Unity Tweak Tool from Ubuntu Software Centre][3] 

### 9. Filter The Noise ###

Ubuntu’s new ‘Smart Scopes’ service promises to be a handy tool, but at present it’s just not as smart as it claims.

The good news is that feature can be switched off with a click, so there’s no need to avoid using Ubuntu altogether.

If you find yourself facing a wall of obscure music results or obtuse shopping suggestions every time you search for something unrelated you can disable each offending scope individually.

![](http://www.omgubuntu.co.uk/wp-content/uploads/2013/10/Screen-Shot-2013-10-15-at-11.36.26-750x480.png)

If you find yourself flooded with irrelevant music results for every search disable the music scopes. Don’t want Amazon suggestions? Switch Amazon off.

### 10. Spread The Word about Ubuntu 13.10 ###

This item on our to-do list is cringe-worthy, I know. But the only way people are going to try out Ubuntu 13.10 is if they know about it – so do your bit and share news of it.

Whether you just post this post to Facebook, or make a LiveUSB for your OS X-loving partner, you’ll be helping raise awareness of Ubuntu.

Don’t forget to enjoy using it, too. Go check your Facebook profile, listen to some music, and  do a bit of surfing in Firefox.

--------------------------------------------------------------------------------

via: http://www.omgubuntu.co.uk/2013/10/10-things-installing-ubuntu-13-10

译者：[译者ID](https://github.com/译者ID) 校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:https://apps.ubuntu.com/cat/applications/ubuntu-restricted-extras/
[2]:http://www.omgubuntu.co.uk/category/app
[3]:apt:unity-tweak-tool